<template>
  <div class="card">
    <div class="card-body">
      <h5 class="card-title">Dataset Difference</h5>

      <!-- <div
        class="col-right mr-2 d-inline dropdown-container"
        role="group"
        aria-label="Sort Dropdown"
      >
        <div class="btn-group ec-sort-dropdown dropdown" role="group">
          <button
            class="colorPrimarySort value-display list-group-item col w-100 d-flex flex-row justify-content-md-between p-0 align-items-center"
            type="button"
            @click="toggleDropdown"
          >
            <div class="pl-2 h-100 d-flex align-items-center">
              {{ selectedLabel }}
            </div>
            <div class="ecl-select__icon ecl-select__icon-Sort">
              <svg
                class="ecl-icon ecl-icon--s ecl-icon--rotate-180 ecl-select__icon-shape"
                focusable="false"
                aria-hidden="true"
              >
                <use
                  xlink:href="../../assets/img/ecl/icons.svg#corner-arrow"
                ></use>
              </svg>
            </div>
          </button>
          <ul
            class="dropdown-menu ec-ds-dropdown-items"
            :class="{ show: dropdownVisible }"
          >
            <li v-for="option in options" :key="option.value">
              <button class="dropdown-item" @click="onSelectionChange(option)">
                {{ option.label }}
              </button>
            </li>
          </ul>
        </div>

        <div
          class="col-right mr-2 d-inline dropdown-container"
          role="group"
          aria-label="Sort Dropdown"
        >
          <div class="btn-group ec-sort-dropdown dropdown" role="group">
            <button
              class="colorPrimarySort value-display list-group-item col w-100 d-flex flex-row justify-content-md-between p-0 align-items-center"
              type="button"
              @click="toggleDropdown"
            >
              <div class="pl-2 h-100 d-flex align-items-center">
                {{ selectedLabel }}
              </div>
              <div class="ecl-select__icon ecl-select__icon-Sort">
                <svg
                  class="ecl-icon ecl-icon--s ecl-icon--rotate-180 ecl-select__icon-shape"
                  focusable="false"
                  aria-hidden="true"
                >
                  <use
                    xlink:href="../../assets/img/ecl/icons.svg#corner-arrow"
                  ></use>
                </svg>
              </div>
            </button>
            <ul
              class="dropdown-menu ec-ds-dropdown-items"
              :class="{ show: dropdownVisible }"
            >
              <li v-for="option in options" :key="option.value">
              <button class="dropdown-item" @click="onSelectionChange(option)">
                {{ option.label }}
              </button>
            </li>
            </ul>
          </div>
        </div>
      </div> -->

      <CodeDiff
        :old-string="oldVersion"
        :new-string="newVersion"
        output-format="side-by-side"
      >
        <template #stat="{ stat }">
          <span class="diff-stat-added"
            >+{{ stat.additionsNum }} {{ addStats }}</span
          >
          <span class="diff-stat-deleted"
            >-{{ stat.deletionsNum }} {{ subStats }}</span
          >
        </template>
      </CodeDiff>
    </div>
  </div>
</template>

<script lang="ts">
import { computed, defineComponent, ref } from "vue";
import { useI18n } from "vue-i18n";

export default defineComponent({
  name: "DatasetDiffDetails",
  props: {
    options: {
      type: Array,
      required: true,
    },
    modelValue: {
      type: String,
      required: true,
    },
  },
  setup(props, { emit }) {
    const dropdownVisible = ref(false);
    const selectedLabel = "abc";
    const oldVersion = ref("");
    const newVersion = ref("");
    // const selectedLabel = ref(
    //   props.options.find((option) => option.value === props.modelValue)
    //     ?.label || ""
    // );

    const toggleDropdown = () => {
      dropdownVisible.value = !dropdownVisible.value;
    };

    const onSelectionChange = (option: { label: string; value: string }) => {
      // selectedLabel.value = option.label;
      emit("update:modelValue", option.value);
      dropdownVisible.value = false;
    };

    const { t, te } = useI18n();

    const addStats = computed(() => {
      return te("message.metadata.datasetRevision.addition")
        ? t("message.metadata.datasetRevision.addition")
        : "Additions";
    });
    const subStats = computed(() => {
      return te("message.metadata.datasetRevision.subtractions")
        ? t("message.metadata.datasetRevision.subtractions")
        : "Subtractions";
    });

    return {
      oldVersion,
      newVersion,
      addStats,
      subStats,
      toggleDropdown,
      dropdownVisible,
      onSelectionChange,
      selectedLabel,
    };
  },
  mounted() {
    const oldData = history.state.oldVersion;
    const newData = history.state.newVersion;

    if (oldData && newData) {
      this.oldVersion = oldData;
      this.newVersion = newData;
    } else {
      // console.error("Data not found in history state.");
    }

    // console.log(this.oldVersion, this.newVersion);
  },
});
</script>
<style scoped>
.card {
  background-color: #f8f9fa;
}
.dropdown-container {
  display: flex;
  gap: 10px;
}

.dropdown {
  position: relative;
  display: inline-block;
}
.dropdown-container {
  margin-top: 1rem;
  display: flex;
  flex-direction: column;
  gap: 0.5rem;
}
.dropdown-container p {
  font-size: 0.95rem;
}
.version-dropdown {
  width: 100%;
  padding: 0.5rem;
  font-size: 1rem;
  border: 1px solid #ccc;
  border-radius: 4px;
  background-color: #fff;
  color: #2c3e50;
  appearance: none;
}
.ec-sort-dropdown {
  width: 300px;
  height: 48px;
}
</style>
